## org.eclipse.jst.jsf.metadataprocessors
Class MetaDataEnabledProcessingFactory

    java.lang.Object
      org.eclipse.jst.jsf.metadataprocessors.MetaDataEnabledProcessingFactory

    public final class MetaDataEnabledProcessingFactory

extends java.lang.Object

Singleton class that will produce `IMetaDataEnabledFeature`s that the caller can use for processing.

Provisional API - subject to change

Field Summary
`static java.lang.String` `ATTRIBUTE_VALUE_RUNTIME_TYPE_PROP_NAME` Name of property in annotation file to use when applying a runtime type to an attribute value

Method Summary

`java.util.List<IMetaDataEnabledFeature>`

`getAttributeValueRuntimeTypeFeatureProcessors(java.lang.Class featureType, IStructuredDocumentContext sdContext, AttributeIdentifier attributeId)`
A convenience method fully equivalent to: getAttributeValueRuntimeTypeFeatureProcessors (featureType, sdContext, attributeId.getTagIdentifier().getUri() , attributeId.getTagIdentifier().getTagName(), attributeId.getName())

`java.util.List<IMetaDataEnabledFeature>` `getAttributeValueRuntimeTypeFeatureProcessors(java.lang.Class featureType, IStructuredDocumentContext sdContext, Entity attrEntity)`
`java.util.List<IMetaDataEnabledFeature>` `getAttributeValueRuntimeTypeFeatureProcessors(java.lang.Class featureType, IStructuredDocumentContext sdContext, java.lang.String uri, java.lang.String elementName, java.lang.String attributeName)` Returns list of `IMetaDataEnabledFeature` adapters for the given Taglibrary attribute.
`static MetaDataEnabledProcessingFactory` `getInstance()`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### ATTRIBUTE_VALUE_RUNTIME_TYPE_PROP_NAME

    public static final java.lang.String ATTRIBUTE_VALUE_RUNTIME_TYPE_PROP_NAME

  Name of property in annotation file to use when applying a runtime type to an attribute value

  See Also:
    Constant Field Values

Method Detail

### getInstance

    public static MetaDataEnabledProcessingFactory getInstance()

  Returns:
    singleton instance

### getAttributeValueRuntimeTypeFeatureProcessors

    public java.util.List<IMetaDataEnabledFeature> getAttributeValueRuntimeTypeFeatureProcessors(java.lang.Class featureType,
                                                                                                 IStructuredDocumentContext sdContext,
                                                                                                 java.lang.String uri,
                                                                                                 java.lang.String elementName,
                                                                                                 java.lang.String attributeName)

  Returns list of `IMetaDataEnabledFeature` adapters for the given Taglibrary attribute. Adapters will be scanned for first by uri, element, attribute and if not found, uri, "*", attribute and if still not found by "*", "*", attribute.

  Parameters:
    `featureType` - feature type. eg. `IPossibleValues`, `IValidValues`, etc. Must be subclass of IMetaDataEnabledFeature.
    `sdContext` -
    `uri` - annotation file uri
    `elementName` -
    `attributeName` -
  Returns:
    returns null - if the metadata was not found
    returns empty list - if not a `IMetaDataEnabledFeature` processor or is not valid or does not support the specified feature
  See Also:
    `ATTRIBUTE_VALUE_RUNTIME_TYPE_PROP_NAME`

### getAttributeValueRuntimeTypeFeatureProcessors

    public java.util.List<IMetaDataEnabledFeature> getAttributeValueRuntimeTypeFeatureProcessors(java.lang.Class featureType,
                                                                                                 IStructuredDocumentContext sdContext,
                                                                                                 AttributeIdentifier attributeId)

  A convenience method fully equivalent to: getAttributeValueRuntimeTypeFeatureProcessors (featureType, sdContext, attributeId.getTagIdentifier().getUri() , attributeId.getTagIdentifier().getTagName(), attributeId.getName())

  Parameters:
    `featureType` -
    `sdContext` -
    `attributeId` -
  Returns:
    the meta-data enabled feature

### getAttributeValueRuntimeTypeFeatureProcessors

    public java.util.List<IMetaDataEnabledFeature> getAttributeValueRuntimeTypeFeatureProcessors(java.lang.Class featureType,
                                                                                                 IStructuredDocumentContext sdContext,
                                                                                                 Entity attrEntity)

  Parameters:
    `featureType` -
    `sdContext` -
    `attrEntity` -
  Returns:
    returns null - if the meta data was not found
    returns empty list - if not a `IMetaDataEnabledFeature` processor or is not valid or does not support the specified feature